// Code generated by crd2pulumi DO NOT EDIT.
// *** WARNING: Do not edit by hand unless you're certain you know what you are doing! ***

package v1alpha1

import (
	"context"
	"reflect"

	"antoine-roux.tk/projects/go/pulumi-library/crds/kubernetes/internal"
	v1 "github.com/pulumi/pulumi-kubernetes/sdk/v4/go/kubernetes/meta/v1"
	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
	"github.com/pulumi/pulumi/sdk/v3/go/pulumix"
)

type DNSEndpoint struct {
	pulumi.CustomResourceState

	ApiVersion pulumi.StringPtrOutput `pulumi:"apiVersion"`
	Kind       pulumi.StringPtrOutput `pulumi:"kind"`
	Metadata   v1.ObjectMetaPtrOutput `pulumi:"metadata"`
	// DNSEndpointSpec defines the desired state of DNSEndpoint
	Spec DNSEndpointSpecPtrOutput `pulumi:"spec"`
	// DNSEndpointStatus defines the observed state of DNSEndpoint
	Status DNSEndpointStatusPtrOutput `pulumi:"status"`
}

// NewDNSEndpoint registers a new resource with the given unique name, arguments, and options.
func NewDNSEndpoint(ctx *pulumi.Context,
	name string, args *DNSEndpointArgs, opts ...pulumi.ResourceOption) (*DNSEndpoint, error) {
	if args == nil {
		args = &DNSEndpointArgs{}
	}

	args.ApiVersion = pulumi.StringPtr("externaldns.k8s.io/v1alpha1")
	args.Kind = pulumi.StringPtr("DNSEndpoint")
	opts = internal.PkgResourceDefaultOpts(opts)
	var resource DNSEndpoint
	err := ctx.RegisterResource("kubernetes:externaldns.k8s.io/v1alpha1:DNSEndpoint", name, args, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// GetDNSEndpoint gets an existing DNSEndpoint resource's state with the given name, ID, and optional
// state properties that are used to uniquely qualify the lookup (nil if not required).
func GetDNSEndpoint(ctx *pulumi.Context,
	name string, id pulumi.IDInput, state *DNSEndpointState, opts ...pulumi.ResourceOption) (*DNSEndpoint, error) {
	var resource DNSEndpoint
	err := ctx.ReadResource("kubernetes:externaldns.k8s.io/v1alpha1:DNSEndpoint", name, id, state, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// Input properties used for looking up and filtering DNSEndpoint resources.
type dnsendpointState struct {
}

type DNSEndpointState struct {
}

func (DNSEndpointState) ElementType() reflect.Type {
	return reflect.TypeOf((*dnsendpointState)(nil)).Elem()
}

type dnsendpointArgs struct {
	ApiVersion *string        `pulumi:"apiVersion"`
	Kind       *string        `pulumi:"kind"`
	Metadata   *v1.ObjectMeta `pulumi:"metadata"`
	// DNSEndpointSpec defines the desired state of DNSEndpoint
	Spec *DNSEndpointSpec `pulumi:"spec"`
	// DNSEndpointStatus defines the observed state of DNSEndpoint
	Status *DNSEndpointStatus `pulumi:"status"`
}

// The set of arguments for constructing a DNSEndpoint resource.
type DNSEndpointArgs struct {
	ApiVersion pulumi.StringPtrInput
	Kind       pulumi.StringPtrInput
	Metadata   v1.ObjectMetaPtrInput
	// DNSEndpointSpec defines the desired state of DNSEndpoint
	Spec DNSEndpointSpecPtrInput
	// DNSEndpointStatus defines the observed state of DNSEndpoint
	Status DNSEndpointStatusPtrInput
}

func (DNSEndpointArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*dnsendpointArgs)(nil)).Elem()
}

type DNSEndpointInput interface {
	pulumi.Input

	ToDNSEndpointOutput() DNSEndpointOutput
	ToDNSEndpointOutputWithContext(ctx context.Context) DNSEndpointOutput
}

func (*DNSEndpoint) ElementType() reflect.Type {
	return reflect.TypeOf((**DNSEndpoint)(nil)).Elem()
}

func (i *DNSEndpoint) ToDNSEndpointOutput() DNSEndpointOutput {
	return i.ToDNSEndpointOutputWithContext(context.Background())
}

func (i *DNSEndpoint) ToDNSEndpointOutputWithContext(ctx context.Context) DNSEndpointOutput {
	return pulumi.ToOutputWithContext(ctx, i).(DNSEndpointOutput)
}

func (i *DNSEndpoint) ToOutput(ctx context.Context) pulumix.Output[*DNSEndpoint] {
	return pulumix.Output[*DNSEndpoint]{
		OutputState: i.ToDNSEndpointOutputWithContext(ctx).OutputState,
	}
}

type DNSEndpointOutput struct{ *pulumi.OutputState }

func (DNSEndpointOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**DNSEndpoint)(nil)).Elem()
}

func (o DNSEndpointOutput) ToDNSEndpointOutput() DNSEndpointOutput {
	return o
}

func (o DNSEndpointOutput) ToDNSEndpointOutputWithContext(ctx context.Context) DNSEndpointOutput {
	return o
}

func (o DNSEndpointOutput) ToOutput(ctx context.Context) pulumix.Output[*DNSEndpoint] {
	return pulumix.Output[*DNSEndpoint]{
		OutputState: o.OutputState,
	}
}

func (o DNSEndpointOutput) ApiVersion() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *DNSEndpoint) pulumi.StringPtrOutput { return v.ApiVersion }).(pulumi.StringPtrOutput)
}

func (o DNSEndpointOutput) Kind() pulumi.StringPtrOutput {
	return o.ApplyT(func(v *DNSEndpoint) pulumi.StringPtrOutput { return v.Kind }).(pulumi.StringPtrOutput)
}

func (o DNSEndpointOutput) Metadata() v1.ObjectMetaPtrOutput {
	return o.ApplyT(func(v *DNSEndpoint) v1.ObjectMetaPtrOutput { return v.Metadata }).(v1.ObjectMetaPtrOutput)
}

// DNSEndpointSpec defines the desired state of DNSEndpoint
func (o DNSEndpointOutput) Spec() DNSEndpointSpecPtrOutput {
	return o.ApplyT(func(v *DNSEndpoint) DNSEndpointSpecPtrOutput { return v.Spec }).(DNSEndpointSpecPtrOutput)
}

// DNSEndpointStatus defines the observed state of DNSEndpoint
func (o DNSEndpointOutput) Status() DNSEndpointStatusPtrOutput {
	return o.ApplyT(func(v *DNSEndpoint) DNSEndpointStatusPtrOutput { return v.Status }).(DNSEndpointStatusPtrOutput)
}

func init() {
	pulumi.RegisterInputType(reflect.TypeOf((*DNSEndpointInput)(nil)).Elem(), &DNSEndpoint{})
	pulumi.RegisterOutputType(DNSEndpointOutput{})
}
